API Classes

Apps

Kelvin API Client.

class kelvin.api.client.api.apps.Apps(_owner=None, _name=None, **kwargs)[source]

Bases: ApiServiceModel

Parameters:
  • _owner (BaseModel | None)

  • _name (str | None)

  • kwargs (object)

classmethod list_apps_context(sort_by=None, pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

List Apps Contexts

Permission Required: kelvin.permission.app.read.

listAppsContext: POST /api/v4/apps/context/list

Parameters:
  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • data (Union[AppsContextList, Mapping[str, object], None]) – requests.AppsContextList, optional

  • **kwargs (object) –

    Extra parameters for requests.AppsContextList
    • list_apps_context: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[AppsResourceContext], AppsContextListPaginatedResponseCursor]

classmethod create_app_version(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create App Version

Permission Required: kelvin.permission.app.create.

createAppVersion: POST /api/v4/apps/create

Parameters:
  • data (Union[AppVersionCreate, Mapping[str, object], None]) – requests.AppVersionCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.AppVersionCreate
    • create_app_version: str

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

AppVersionCreate

classmethod list_apps(app_names=None, app_types=None, resources=None, search=None, sort_by=None, pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, fetch=True, _dry_run=False, _client=None)[source]

Returns a list of Applications based on the provided filters and sort options.

Permission Required: kelvin.permission.app.read.

listApps: GET /api/v4/apps/list

Parameters:
  • app_names (Optional[Sequence[str]]) – Sequence[str] Filter the results by the provided application names.

  • app_types (Optional[Sequence[str]]) – Sequence[str] Application type.

  • resources (Optional[Sequence[str]]) – Sequence[str] Filter based on Resource (KRN format) associated with the App. Supported KRNs: asset.

  • search (Optional[Sequence[str]]) – Sequence[str] Search the name or title of the application for the provided string.

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

Union[KList[AppShort], AppsListPaginatedResponseCursor]

classmethod delete_app(app_name, _dry_run=False, _client=None)[source]

Delete App

Permission Required: kelvin.permission.app.delete.

deleteApp: POST /api/v4/apps/{app_name}/delete

Parameters:
  • app_name (str) – str, optional

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

None

classmethod get_app(app_name, _dry_run=False, _client=None)[source]

Get details of an Application

Permission Required: kelvin.permission.app.read.

getApp: GET /api/v4/apps/{app_name}/get

Parameters:
  • app_name (str) – str, optional

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

AppGet

classmethod patch_app(app_name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Update details of an Application. Any parameters that are not provided will remain unchanged.

Permission Required: kelvin.permission.app.update.

patchApp: POST /api/v4/apps/{app_name}/patch

Parameters:
  • app_name (str) – str, optional

  • data (Union[AppPatch, Mapping[str, object], None]) – requests.AppPatch, optional

  • **kwargs (object) –

    Extra parameters for requests.AppPatch
    • patch_app: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

AppPatch

classmethod delete_app_resources(app_name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Delete App Resources

Permission Required: kelvin.permission.app.update.

deleteAppResources: POST /api/v4/apps/{app_name}/resources/delete

Parameters:
  • app_name (str) – str, optional

  • data (Union[AppResourcesDelete, Mapping[str, object], None]) – requests.AppResourcesDelete, optional

  • **kwargs (object) –

    Extra parameters for requests.AppResourcesDelete
    • delete_app_resources: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod disable_app_resources(app_name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Disable App Resources

Permission Required: kelvin.permission.app.update.

disableAppResources: POST /api/v4/apps/{app_name}/resources/disable

Parameters:
  • app_name (str) – str, optional

  • data (Union[AppResourcesDisable, Mapping[str, object], None]) – requests.AppResourcesDisable, optional

  • **kwargs (object) –

    Extra parameters for requests.AppResourcesDisable
    • disable_app_resources: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod enable_app_resources(app_name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Enable App Resources

Permission Required: kelvin.permission.app.update.

enableAppResources: POST /api/v4/apps/{app_name}/resources/enable

Parameters:
  • app_name (str) – str, optional

  • data (Union[AppResourcesEnable, Mapping[str, object], None]) – requests.AppResourcesEnable, optional

  • **kwargs (object) –

    Extra parameters for requests.AppResourcesEnable
    • enable_app_resources: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod list_app_resources(app_name, search=None, resources=None, app_versions=None, workload_names=None, enabled=None, sort_by=None, pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, fetch=True, _dry_run=False, _client=None)[source]

List App Resources

Permission Required: kelvin.permission.app.read.

listAppResources: GET /api/v4/apps/{app_name}/resources/list

Parameters:
  • app_name (str) – str, optional

  • search (Optional[Sequence[str]]) – Sequence[str]

  • resources (Optional[Sequence[str]]) – Sequence[str]

  • app_versions (Optional[Sequence[str]]) – Sequence[str]

  • workload_names (Optional[Sequence[str]]) – Sequence[str]

  • enabled (Optional[bool]) – bool

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

Union[KList[AppResource], AppResourcesListPaginatedResponseCursor]

classmethod delete_app_version(app_name, app_version, _dry_run=False, _client=None)[source]

Delete App Version

Permission Required: kelvin.permission.app.delete.

deleteAppVersion: POST /api/v4/apps/{app_name}/v/{app_version}/delete

Parameters:
  • app_name (str) – str, optional

  • app_version (str) – str, optional

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

None

classmethod deploy_app_version(app_name, app_version, data=None, _dry_run=False, _client=None, **kwargs)[source]

Deploy App Version

Issues the deployment of workloads based on the specified instructions.

The deployment section defines the strategy to deploy the application to resources (i.e. assets) by creating the necessary workloads based on the maximum number of resources each instance can handle, as well as the target cluster where the workloads will be deployed.

Each resource (i.e. asset) is defined in the runtime section, which includes defining its parameters and data stream mappings.

The parameters section is optional. If provided, it will update all parameters for that resource with the provided values, otherwise, the current ones will be injected into the new workloads. If parameters is set and a parameter is not defined, the current value will be deleted, effectively setting it to the default value. This behaviour means that setting parameters to an empty object ({}) will reset all parameters of that resource to their default values.

Permission Required: kelvin.permission.app.deploy.

deployAppVersion: POST /api/v4/apps/{app_name}/v/{app_version}/deploy

Parameters:
  • app_name (str) – str, optional

  • app_version (str) – str, optional

  • data (Union[AppVersionDeploy, Mapping[str, object], None]) – requests.AppVersionDeploy, optional

  • **kwargs (object) –

    Extra parameters for requests.AppVersionDeploy
    • deploy_app_version: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

AppVersionDeploy

classmethod get_app_version(app_name, app_version, _dry_run=False, _client=None)[source]

Get App Version

Permission Required: kelvin.permission.app.read.

getAppVersion: GET /api/v4/apps/{app_name}/v/{app_version}/get

Parameters:
  • app_name (str) – str, optional

  • app_version (str) – str, optional

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

AppVersionGet

classmethod patch_app_version(app_name, app_version, data=None, _dry_run=False, _client=None, **kwargs)[source]

Update App Version

Partially update the default settings and schemas for an App Version. The following keys can be updated individually. If a key is not specified, its existing value will remain unchanged. If a key is specified, it will completely overwrite the current value for that key and its nested fields.

  • defaults.deployment.max_resources

  • defaults.deployment.deployment_type

  • defaults.deployment.target

  • defaults.app.configuration

  • defaults.app.io_datastream_mapping

  • defaults.system

  • schemas.parameters

  • schemas.configuration

  • schemas.io_configuration

Permission Required: kelvin.permission.app.update.

patchAppVersion: POST /api/v4/apps/{app_name}/v/{app_version}/patch

Parameters:
  • app_name (str) – str, optional

  • app_version (str) – str, optional

  • data (Union[AppVersionPatch, Mapping[str, object], None]) – requests.AppVersionPatch, optional

  • **kwargs (object) –

    Extra parameters for requests.AppVersionPatch
    • patch_app_version: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

AppVersionPatch

classmethod update_app_version(app_name, app_version, data=None, _dry_run=False, _client=None, **kwargs)[source]

Update App Version

Update the default settings and schemas for an App Version.

Permission Required: kelvin.permission.app.update.

updateAppVersion: POST /api/v4/apps/{app_name}/v/{app_version}/update

Parameters:
  • app_name (str) – str, optional

  • app_version (str) – str, optional

  • data (Union[AppVersionUpdate, Mapping[str, object], None]) – requests.AppVersionUpdate, optional

  • **kwargs (object) –

    Extra parameters for requests.AppVersionUpdate
    • update_app_version: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

AppVersionUpdate

fields = None
model_config = {'extra': 'allow', 'use_enum_values': True, 'validate_assignment': True, 'validate_default': True}

Configuration for the model, should be a dictionary conforming to [ConfigDict][pydantic.config.ConfigDict].

model_post_init(context, /)

This function is meant to behave like a BaseModel method to initialise private attributes.

It takes context as an argument since that’s what pydantic-core passes when calling it.

Parameters:
  • self (BaseModel) – The BaseModel instance.

  • context (Any) – The context.

Return type:

None

schema = None

AppParameters

Kelvin API Client.

class kelvin.api.client.api.app_parameters.AppParameters(_owner=None, _name=None, **kwargs)[source]

Bases: ApiServiceModel

Parameters:
  • _owner (Optional['BaseModel'])

  • _name (Optional[str])

  • kwargs (object)

classmethod list_app_version_parameters_history(sort_by=None, pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

List App Version Parameters History

Permission Required: kelvin.permission.parameter.read.

listAppVersionParametersHistory: POST /api/v4/apps/parameters/history/list

Parameters:
  • sort_by (Optional[Sequence[str]]) – Sequence[str] Sort the results by one or more enumerators.

  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • data (Union[AppVersionParametersHistoryList, Mapping[str, object], None]) – requests.AppVersionParametersHistoryList, optional

  • **kwargs (object) –

    Extra parameters for requests.AppVersionParametersHistoryList
    • list_app_version_parameters_history: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[AppVersionParameter], AppVersionParametersHistoryListPaginatedResponseCursor]

classmethod list_app_parameters(sort_by=None, pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

List App Parameters

Permission Required: kelvin.permission.parameter.read.

listAppParameters: POST /api/v4/apps/parameters/list

Parameters:
  • sort_by (Optional[Sequence[str]]) – Sequence[str] Sort the results by one or more enumerators.

  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • data (Union[AppParametersList, Mapping[str, object], None]) – requests.AppParametersList, optional

  • **kwargs (object) –

    Extra parameters for requests.AppParametersList
    • list_app_parameters: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[AppParameter], AppParametersListPaginatedResponseCursor]

classmethod create_parameters_schedule(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create a new schedule to apply parameters to an application.

Schedules are sets of application parameter values that are applied to a group of assets at a given time.

Optionally, those values can be reverted to the desired value. When doing so, parameter values are defined for each asset individually, and the assets and parameters must match the original schedule. For example, if 2 parameters were changed for 2 assets and a revert operation is requested, then the revert parameters must have 2 assets and 2 parameters for each asset.

The schedule must be created in the future and, if a revert operation is requested, the revert date must be after the scheduled date.

Upon creation, the current values of the parameters are stored in the original_resource_parameters field.

Permission Required: kelvin.permission.parameter.update.

createParametersSchedule: POST /api/v4/apps/parameters/schedules/create

Parameters:
  • data (Union[ParametersScheduleCreate, Mapping[str, object], None]) – requests.ParametersScheduleCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.ParametersScheduleCreate
    • create_parameters_schedule: str

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

ParametersScheduleCreate

classmethod list_parameters_schedule(pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

Returns a list of Parameter Schedules and its parameters. The Parameter Schedules can be optionally filtered and sorted on the server before being returned.

Permission Required: kelvin.permission.parameter.read.

listParametersSchedule: POST /api/v4/apps/parameters/schedules/list

Parameters:
  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str] Sort the results by one or more enumerators.

  • data (Union[ParametersScheduleList, Mapping[str, object], None]) – requests.ParametersScheduleList, optional

  • **kwargs (object) –

    Extra parameters for requests.ParametersScheduleList
    • list_parameters_schedule: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[ParametersScheduleGet], ParametersScheduleListPaginatedResponseCursor]

classmethod apply_parameters_schedule(schedule_id, data=None, _dry_run=False, _client=None, **kwargs)[source]

Apply the scheduled or reverted parameters of a specific schedule.

There are 2 types of the “apply” action:

  • schedule: Applies the scheduled parameters if the schedule is in the

scheduled state. - schedule-revert: Applies the revert parameters if the schedule is in the scheduled-revert state.

If the schedule is not in the supported state for the selected type, the API will return an error.

Errors encountered when calling this API will not affect the schedule state.

Permission Required: kelvin.permission.parameter.update.

applyParametersSchedule: POST /api/v4/apps/parameters/schedules/{schedule_id}/apply

Parameters:
  • schedule_id (str) – str, optional The parameter schedule key id to be applied immediately.

  • data (Union[ParametersScheduleApply, Mapping[str, object], None]) – requests.ParametersScheduleApply, optional

  • **kwargs (object) –

    Extra parameters for requests.ParametersScheduleApply
    • apply_parameters_schedule: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod delete_parameters_schedule(schedule_id, _dry_run=False, _client=None)[source]

Delete a specific schedule.

Permission Required: kelvin.permission.parameter.update.

deleteParametersSchedule: POST /api/v4/apps/parameters/schedules/{schedule_id}/delete

Parameters:
  • schedule_id (str) – str, optional The parameter schedule key id to be delete.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

None

classmethod get_parameters_schedule(schedule_id, _dry_run=False, _client=None)[source]

Get a specific schedule.

Permission Required: kelvin.permission.parameter.read.

getParametersSchedule: GET /api/v4/apps/parameters/schedules/{schedule_id}/get

Parameters:
  • schedule_id (str) – str, optional The parameter schedule key id to be retrieved.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

ParametersScheduleGet

classmethod get_app_version_parameters_unique_values(data=None, _dry_run=False, _client=None, **kwargs)[source]

Get App Version Parameters Unique Values

Permission Required: kelvin.permission.parameter.read.

getAppVersionParametersUniqueValues: POST /api/v4/apps/parameters/unique-values/get

Parameters:
  • data (Union[AppVersionParametersUniqueValuesGet, Mapping[str, object], None]) – requests.AppVersionParametersUniqueValuesGet, optional

  • **kwargs (object) –

    Extra parameters for requests.AppVersionParametersUniqueValuesGet
    • get_app_version_parameters_unique_values: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

AppVersionParametersUniqueValuesGet

classmethod list_app_version_parameter_values(sort_by=None, pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

List App Version Parameter Values

Permission Required: kelvin.permission.parameter.read.

listAppVersionParameterValues: POST /api/v4/apps/parameters/values/list

Parameters:
  • sort_by (Optional[Sequence[str]]) – Sequence[str] Sort the results by one or more enumerators.

  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • data (Union[AppVersionParameterValuesList, Mapping[str, object], None]) – requests.AppVersionParameterValuesList, optional

  • **kwargs (object) –

    Extra parameters for requests.AppVersionParameterValuesList
    • list_app_version_parameter_values: str

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[AppVersionParameter], AppVersionParameterValuesListPaginatedResponseCursor]

classmethod update_app_version_parameters_defaults(app_name, app_version, patch=None, data=None, _dry_run=False, _client=None, **kwargs)[source]

Update App Version Parameters Defaults

Permission Required: kelvin.permission.app.update.

updateAppVersionParametersDefaults: POST /api/v4/apps/{app_name}/v/{app_version}/parameters/defaults/update

Parameters:
  • app_name (str) – str, optional

  • app_version (str) – str, optional

  • patch (Optional[bool]) – bool If set to true, it only updates the parameters that are explicitly defined in the request.

  • data (Union[AppVersionParametersDefaultsUpdate, Mapping[str, object], None]) – requests.AppVersionParametersDefaultsUpdate, optional

  • **kwargs (object) –

    Extra parameters for requests.AppVersionParametersDefaultsUpdate
    • update_app_version_parameters_defaults: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod get_app_version_parameters_fallback_values(app_name, app_version, data=None, _dry_run=False, _client=None, **kwargs)[source]

Get App Version Parameters Fallback Values

Permission Required: kelvin.permission.parameter.read.

getAppVersionParametersFallbackValues: POST /api/v4/apps/{app_name}/v/{app_version}/parameters/fallback-values/get

Parameters:
  • app_name (str) – str, optional

  • app_version (str) – str, optional

  • data (Union[AppVersionParametersFallbackValuesGet, Mapping[str, object], None]) – requests.AppVersionParametersFallbackValuesGet, optional

  • **kwargs (object) –

    Extra parameters for requests.AppVersionParametersFallbackValuesGet
    • get_app_version_parameters_fallback_values: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

AppVersionParametersFallbackValuesGet

classmethod update_app_version_parameters(app_name, app_version, patch=None, data=None, _dry_run=False, _client=None, **kwargs)[source]

Update App Version Parameters

Permission Required: kelvin.permission.parameter.update.

updateAppVersionParameters: POST /api/v4/apps/{app_name}/v/{app_version}/parameters/values/update

Parameters:
  • app_name (str) – str, optional

  • app_version (str) – str, optional

  • patch (Optional[bool]) – bool If set to true, it only updates the parameters that are explicitly defined in the request.

  • data (Union[AppVersionParametersUpdate, Mapping[str, object], None]) – requests.AppVersionParametersUpdate, optional

  • **kwargs (object) –

    Extra parameters for requests.AppVersionParametersUpdate
    • update_app_version_parameters: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

fields = None
model_config = {'extra': 'allow', 'use_enum_values': True, 'validate_assignment': True, 'validate_default': True}

Configuration for the model, should be a dictionary conforming to [ConfigDict][pydantic.config.ConfigDict].

model_post_init(context, /)

This function is meant to behave like a BaseModel method to initialise private attributes.

It takes context as an argument since that’s what pydantic-core passes when calling it.

Parameters:
  • self (BaseModel) – The BaseModel instance.

  • context (Any) – The context.

Return type:

None

schema = None

AppWorkloads

Kelvin API Client.

class kelvin.api.client.api.app_workloads.AppWorkloads(_owner=None, _name=None, **kwargs)[source]

Bases: ApiServiceModel

Parameters:
  • _owner (Optional['BaseModel'])

  • _name (Optional[str])

  • kwargs (object)

classmethod apply_workloads(data=None, _dry_run=False, _client=None, **kwargs)[source]

Initiate final deploy action for the downloaded Workloads. Only valid for Workloads that were previously deployed with the keys staged set to true and instantly_apply set to false.

Permission Required: kelvin.permission.workload.update.

applyWorkloads: POST /api/v4/apps/workloads/apply

Parameters:
  • data (Union[WorkloadsApply, Mapping[str, object], None]) – requests.WorkloadsApply, optional

  • **kwargs (object) –

    Extra parameters for requests.WorkloadsApply
    • apply_workloads: str

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod update_workloads_bulk(data=None, _dry_run=False, _client=None, **kwargs)[source]

Update Workloads Bulk

Permission Required: kelvin.permission.workload.update.

updateWorkloadsBulk: POST /api/v4/apps/workloads/bulk/update

Parameters:
  • data (Union[WorkloadsBulkUpdate, Mapping[str, object], None]) – requests.WorkloadsBulkUpdate, optional

  • **kwargs (object) –

    Extra parameters for requests.WorkloadsBulkUpdate
    • update_workloads_bulk: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod create_workload(stopped=None, data=None, _dry_run=False, _client=None, **kwargs)[source]

Create Workload

Permission Required: kelvin.permission.workload.create.

createWorkload: POST /api/v4/apps/workloads/create

Parameters:
  • stopped (Optional[bool]) – bool If set to true, the workload created will be deployed in a stopped state.

  • data (Union[WorkloadCreate, Mapping[str, object], None]) – requests.WorkloadCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.WorkloadCreate
    • create_workload: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

WorkloadCreate

classmethod delete_workloads(staged=None, data=None, _dry_run=False, _client=None, **kwargs)[source]

Delete Workload

Permission Required: kelvin.permission.workload.delete.

deleteWorkloads: POST /api/v4/apps/workloads/delete

Parameters:
Return type:

None

classmethod list_workloads(search=None, app_names=None, app_versions=None, app_types=None, cluster_names=None, node_names=None, workload_names=None, resources=None, staged=None, statuses=None, download_statuses=None, sort_by=None, pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, fetch=True, _dry_run=False, _client=None)[source]

List Workloads

Permission Required: kelvin.permission.workload.read.

listWorkloads: GET /api/v4/apps/workloads/list

Parameters:
  • search (Optional[Sequence[str]]) – Sequence[str] Search and filter on the list based on the keys name, title (Display Name), app_name and cluster_name. All strings in the array are treated as _OR_. The search is case insensitive and will find partial matches as well.

  • app_names (Optional[Sequence[str]]) – Sequence[str] A filter on the list based on the key app_name. The filter is on the full name only.

  • app_versions (Optional[Sequence[str]]) – Sequence[str] A filter on the list based on the key app_version. The filter is on the full value only.

  • app_types (Optional[Sequence[str]]) – Sequence[str] Filter Workloads by their application types.

  • cluster_names (Optional[Sequence[str]]) – Sequence[str] A filter on the list based on the key cluster_name. The filter is on the full name only.

  • node_names (Optional[Sequence[str]]) – Sequence[str] A filter on the list based on the key node_name. The filter is on the full name only.

  • workload_names (Optional[Sequence[str]]) – Sequence[str] A filter on the list based on the key name. The filter is on the full name only.

  • resources (Optional[str]) – str Filter based on Resource (KRN format) associated with the Workload. Supported KRNs: asset.

  • staged (Optional[bool]) – bool A filter on the key staged. Using true will only show staged workloads, false will show all workloads.

  • statuses (Optional[Sequence[str]]) – Sequence[str]

  • download_statuses (Optional[Sequence[str]]) – Sequence[str]

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

Union[KList[WorkloadSummary], WorkloadsListPaginatedResponseCursor]

classmethod start_workloads(data=None, _dry_run=False, _client=None, **kwargs)[source]

Permission Required: kelvin.permission.workload.update.

startWorkloads: POST /api/v4/apps/workloads/start

Parameters:
  • data (Union[WorkloadsStart, Mapping[str, object], None]) – requests.WorkloadsStart, optional

  • **kwargs (object) –

    Extra parameters for requests.WorkloadsStart
    • start_workloads: str

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod stop_workloads(data=None, _dry_run=False, _client=None, **kwargs)[source]

Permission Required: kelvin.permission.workload.update.

stopWorkloads: POST /api/v4/apps/workloads/stop

Parameters:
  • data (Union[WorkloadsStop, Mapping[str, object], None]) – requests.WorkloadsStop, optional

  • **kwargs (object) –

    Extra parameters for requests.WorkloadsStop
    • stop_workloads: str

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod download_workload(workload_name, address=None, _dry_run=False, _client=None)[source]

Download the Workload package file for offline installation on the Edge System. The system automatically generates the file for download if the package is not already available.

Permission Required: kelvin.permission.workload.read.

downloadWorkload: GET /api/v4/apps/workloads/{workload_name}/download

Parameters:
  • workload_name (str) – str, optional Unique identifier name of the Workload.

  • address (Optional[bool]) – bool If true, the endpoint will return a direct URL to the workload package file.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

str

classmethod get_workload(workload_name, _dry_run=False, _client=None)[source]

Retrieve the parameters of a Workload.

Permission Required: kelvin.permission.workload.read.

getWorkload: GET /api/v4/apps/workloads/{workload_name}/get

Parameters:
  • workload_name (str) – str, optional Unique identifier name of the Workload.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

WorkloadGet

classmethod get_workload_logs(workload_name, tail_lines=None, since_time=None, _dry_run=False, _client=None)[source]

Get Workload Logs

Permission Required: kelvin.permission.workload.read.

getWorkloadLogs: GET /api/v4/apps/workloads/{workload_name}/logs/get

Parameters:
  • workload_name (str) – str, optional Unique identifier name of the Workload.

  • tail_lines (Optional[int]) – int Specify the number of the most recent log lines to retrieve, counting backwards from the latest entry.

  • since_time (Optional[datetime]) – datetime UTC time of the starting point for log retrieval, formatted in RFC 3339.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

WorkloadLogsGet

classmethod update_workload(workload_name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Update Workload

Update the modifiable components of a Workload. The following keys can be updated individually. If a key is not specified, its existing value will remain unchanged. If a key is specified, it will completely overwrite the current value for that key and its nested fields.

  • app_version

  • cluster_name

  • node_name

  • workload_title

  • runtime.resources

  • runtime.configuration

  • system

Permission Required: kelvin.permission.workload.update.

updateWorkload: POST /api/v4/apps/workloads/{workload_name}/patch

Parameters:
  • workload_name (str) – str, optional

  • data (Union[WorkloadUpdate, Mapping[str, object], None]) – requests.WorkloadUpdate, optional

  • **kwargs (object) –

    Extra parameters for requests.WorkloadUpdate
    • update_workload: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

WorkloadUpdate

classmethod add_workload_resources(workload_name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Add WorkloadResources

Permission Required: kelvin.permission.workload.update.

addWorkloadResources: POST /api/v4/apps/workloads/{workload_name}/resources/add

Parameters:
  • workload_name (str) – str, optional

  • data (Union[WorkloadResourcesAdd, Mapping[str, object], None]) – requests.WorkloadResourcesAdd, optional

  • **kwargs (object) –

    Extra parameters for requests.WorkloadResourcesAdd
    • add_workload_resources: str

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

WorkloadResourcesAdd

classmethod remove_workload_resources(workload_name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Remove WorkloadResources

Permission Required: kelvin.permission.workload.update.

removeWorkloadResources: POST /api/v4/apps/workloads/{workload_name}/resources/remove

Parameters:
  • workload_name (str) – str, optional

  • data (Union[WorkloadResourcesRemove, Mapping[str, object], None]) – requests.WorkloadResourcesRemove, optional

  • **kwargs (object) –

    Extra parameters for requests.WorkloadResourcesRemove
    • remove_workload_resources: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

fields = None
model_config = {'extra': 'allow', 'use_enum_values': True, 'validate_assignment': True, 'validate_default': True}

Configuration for the model, should be a dictionary conforming to [ConfigDict][pydantic.config.ConfigDict].

model_post_init(context, /)

This function is meant to behave like a BaseModel method to initialise private attributes.

It takes context as an argument since that’s what pydantic-core passes when calling it.

Parameters:
  • self (BaseModel) – The BaseModel instance.

  • context (Any) – The context.

Return type:

None

schema = None

Asset

Kelvin API Client.

class kelvin.api.client.api.asset.Asset(_owner=None, _name=None, **kwargs)[source]

Bases: ApiServiceModel

Parameters:
  • _owner (Optional['BaseModel'])

  • _name (Optional[str])

  • kwargs (object)

classmethod create_asset_bulk(dry_run=None, data=None, _dry_run=False, _client=None, **kwargs)[source]

Create new Assets.

Permission Required: kelvin.permission.asset.create.

createAssetBulk: POST /api/v4/assets/bulk/create

Parameters:
  • dry_run (Optional[bool]) – bool Executes a simulated run when set to true, providing feedback without altering server data.

  • data (Union[AssetBulkCreate, Mapping[str, object], None]) – requests.AssetBulkCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.AssetBulkCreate
    • create_asset_bulk: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod delete_asset_bulk(data=None, _dry_run=False, _client=None, **kwargs)[source]

Delete a list of existing Assets.

Permanently delete a list of existing Kelvin Assets. This cannot be undone once the API request has been submitted.

Permission Required: kelvin.permission.asset.delete.

deleteAssetBulk: POST /api/v4/assets/bulk/delete

Parameters:
  • data (Union[AssetBulkDelete, Mapping[str, object], None]) – requests.AssetBulkDelete, optional

  • **kwargs (object) –

    Extra parameters for requests.AssetBulkDelete
    • delete_asset_bulk: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod create_asset(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create a new Asset.

Permission Required: kelvin.permission.asset.create.

createAsset: POST /api/v4/assets/create

Parameters:
  • data (Union[AssetCreate, Mapping[str, object], None]) – requests.AssetCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.AssetCreate
    • create_asset: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

AssetCreate

classmethod list_assets(search=None, names=None, asset_type_name=None, status_state=None, pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, fetch=True, _dry_run=False, _client=None)[source]

Returns a list of Assets and its parameters. The Assets can be optionally filtered and sorted on the server before being returned.

Permission Required: kelvin.permission.asset.read.

listAssets: GET /api/v4/assets/list

Parameters:
  • search (Optional[Sequence[str]]) – Sequence[str] Search and filter on the list based on the keys title (Display Name) or name. All values in array will be filtered as OR. The search is case insensitive and will find partial matches as well.

  • names (Optional[Sequence[str]]) – Sequence[str] A filter on the list based on the key name. The filter is on the full name only. The string can only contain lowercase alphanumeric characters and ., _ or - characters.

  • asset_type_name (Optional[Sequence[str]]) – Sequence[str] A filter on the list based on the key asset_type_name. The filter is on the full name only. The string can only contain lowercase alphanumeric characters and ., _ or - characters.

  • status_state (Optional[Sequence[str]]) – Sequence[str] A filter on the list based on the key [‘status’][‘state’]. Multiple statuses can be given and will be filtered as OR. The allowed values are: online, offline, unknown.

  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

Union[KList[Asset], AssetsListPaginatedResponseCursor]

classmethod list_assets_advanced(pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

Returns a list of Assets and its parameters. The Assets can be filtered and sorted on the server before being returned. Advanced filter options available for more granular return list.

Permission Required: kelvin.permission.asset.read.

listAssetsAdvanced: POST /api/v4/assets/list

Parameters:
  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • data (Union[AssetsAdvancedList, Mapping[str, object], None]) – requests.AssetsAdvancedList, optional

  • **kwargs (object) –

    Extra parameters for requests.AssetsAdvancedList
    • list_assets_advanced: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[Asset], AssetsAdvancedListPaginatedResponseCursor]

classmethod get_asset_status_count(_dry_run=False, _client=None)[source]

Retrieve the total count of Assets grouped by the parameter status.

Permission Required: kelvin.permission.asset.read.

getAssetStatusCount: GET /api/v4/assets/status/count/get

Return type:

AssetStatusCountGet

Parameters:
  • _dry_run (bool)

  • _client (SyncBaseClient | None)

classmethod get_asset_status_current(_dry_run=False, _client=None)[source]

Returns a list of all Assets and their current status (state).

Permission Required: kelvin.permission.asset.read.

getAssetStatusCurrent: GET /api/v4/assets/status/current/get

Return type:

AssetStatusCurrentGet

Parameters:
  • _dry_run (bool)

  • _client (SyncBaseClient | None)

classmethod create_asset_type(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create a new Asset Type.

Permission Required: kelvin.permission.asset_type.create.

createAssetType: POST /api/v4/assets/types/create

Parameters:
  • data (Union[AssetTypeCreate, Mapping[str, object], None]) – requests.AssetTypeCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.AssetTypeCreate
    • create_asset_type: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

AssetTypeCreate

classmethod delete_asset_type_bulk(data=None, _dry_run=False, _client=None, **kwargs)[source]

Delete a list of existing Asset Types.

Permanently delete a list of existing Kelvin Asset Types. This cannot be undone once the API request has been submitted.

This command can not delete Kelvin Asset Types that are currently linked to any Kelvin Assets and will return an error 409.

Permission Required: kelvin.permission.asset_type.delete.

deleteAssetTypeBulk: POST /api/v4/assets/types/delete

Parameters:
  • data (Union[AssetTypeBulkDelete, Mapping[str, object], None]) – requests.AssetTypeBulkDelete, optional

  • **kwargs (object) –

    Extra parameters for requests.AssetTypeBulkDelete
    • delete_asset_type_bulk: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod list_asset_types(search=None, pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, fetch=True, _dry_run=False, _client=None)[source]

Returns a list of Asset Types and its parameters. The Asset Types can be optionally filtered and sorted on the server before being returned.

Permission Required: kelvin.permission.asset_type.read.

listAssetTypes: GET /api/v4/assets/types/list

Parameters:
  • search (Optional[Sequence[str]]) – Sequence[str] Search and filter on the list based on the keys title (Display Name) or name. The search is case insensitive and will find partial matches as well.

  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

Union[KList[AssetType], AssetTypesListPaginatedResponseCursor]

classmethod list_asset_types_advanced(pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

Returns a list of Asset Types and its parameters. The Asset Types can be optionally filtered and sorted on the server before being returned.

Permission Required: kelvin.permission.asset_type.read.

listAssetTypesAdvanced: POST /api/v4/assets/types/list

Parameters:
  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • data (Union[AssetTypesAdvancedList, Mapping[str, object], None]) – requests.AssetTypesAdvancedList, optional

  • **kwargs (object) –

    Extra parameters for requests.AssetTypesAdvancedList
    • list_asset_types_advanced: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[AssetType], AssetTypesAdvancedListPaginatedResponseCursor]

classmethod delete_asset_type(asset_type_name, _dry_run=False, _client=None)[source]

Permanently delete an existing Asset Type. An error will be returned if there are any current links to an Asset. This cannot be undone once the API request has been submitted.

Permission Required: kelvin.permission.asset_type.delete.

deleteAssetType: POST /api/v4/assets/types/{asset_type_name}/delete

Parameters:
  • asset_type_name (str) – str, optional Asset Type key name to delete. The string can only contain lowercase alphanumeric characters and ., _ or - characters.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

None

classmethod get_asset_type(asset_type_name, _dry_run=False, _client=None)[source]

Retrieves the parameters of an Asset Type. Permission Required: kelvin.permission.asset_type.read.

getAssetType: GET /api/v4/assets/types/{asset_type_name}/get

Parameters:
  • asset_type_name (str) – str, optional Asset Type key name to get. The string can only contain lowercase alphanumeric characters and ., _ or - characters.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

AssetTypeGet

classmethod update_asset_type(asset_type_name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Updates an existing Asset Type with any new values passed through the body parameters. All body parameters are optional and if not provided will remain unchanged. Only the unique identifier name can not be changed.

Permission Required: kelvin.permission.asset_type.update.

updateAssetType: POST /api/v4/assets/types/{asset_type_name}/update

Parameters:
  • asset_type_name (str) – str, optional Asset Type key name to update. The string can only contain lowercase alphanumeric characters and ., _ or - characters.

  • data (Union[AssetTypeUpdate, Mapping[str, object], None]) – requests.AssetTypeUpdate, optional

  • **kwargs (object) –

    Extra parameters for requests.AssetTypeUpdate
    • update_asset_type: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

AssetTypeUpdate

classmethod delete_asset(asset_name, _dry_run=False, _client=None)[source]

Permanently delete an existing Asset. This cannot be undone once the API request has been submitted.

The data in the Asset / Data Stream pairs is not deleted and can be recovered if you create the same Asset name again.

Permission Required: kelvin.permission.asset.delete.

deleteAsset: POST /api/v4/assets/{asset_name}/delete

Parameters:
  • asset_name (str) – str, optional Asset key name to delete. The string can only contain lowercase alphanumeric characters and ., _ or - characters.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

None

classmethod get_asset(asset_name, _dry_run=False, _client=None)[source]

Retrieve the parameters of an Asset.

Permission Required: kelvin.permission.asset.read.

getAsset: GET /api/v4/assets/{asset_name}/get

Parameters:
  • asset_name (str) – str, optional Asset key name to get. The string can only contain lowercase alphanumeric characters and ., _ or - characters.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

AssetGet

classmethod update_asset(asset_name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Update an existing Asset with any new values passed through the body parameters. The minimum required in the body parameters is title. If this body parameter does not need to be changed, it should still have the original Display Name (title`) given. Any other body parameters that are not required and not provided will remain unchanged.

Permission Required: kelvin.permission.asset.update.

updateAsset: POST /api/v4/assets/{asset_name}/update

Parameters:
  • asset_name (str) – str, optional Asset key name to get. The string can only contain lowercase alphanumeric characters and ., _ or - characters.

  • data (Union[AssetUpdate, Mapping[str, object], None]) – requests.AssetUpdate, optional

  • **kwargs (object) –

    Extra parameters for requests.AssetUpdate
    • update_asset: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

AssetUpdate

fields = None
model_config = {'extra': 'allow', 'use_enum_values': True, 'validate_assignment': True, 'validate_default': True}

Configuration for the model, should be a dictionary conforming to [ConfigDict][pydantic.config.ConfigDict].

model_post_init(context, /)

This function is meant to behave like a BaseModel method to initialise private attributes.

It takes context as an argument since that’s what pydantic-core passes when calling it.

Parameters:
  • self (BaseModel) – The BaseModel instance.

  • context (Any) – The context.

Return type:

None

schema = None

AssetInsights

Kelvin API Client.

class kelvin.api.client.api.asset_insights.AssetInsights(_owner=None, _name=None, **kwargs)[source]

Bases: ApiServiceModel

Parameters:
  • _owner (Optional['BaseModel'])

  • _name (Optional[str])

  • kwargs (object)

classmethod get_asset_insights(page_size=10000, page=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

Advanced Asset Insights collates Asset data and optional custom defined fields and returns a structured array of Asset related objects. Ideal for generating UI lists, it accommodates a range of search, filter, and optional data on Data Streams, Parameters, Control Changes, Recommendations, etc. related to the Asset.

Permission Required: kelvin.permission.asset_insights.read.

getAssetInsights: POST /api/v4/asset-insights/get

Parameters:
  • page_size (Optional[int]) – int Number of Asset objects to be returned.

  • page (Optional[int]) – int Return the list of Asset objects on requested page using the page_size as a page calculation reference.

  • data (Union[AssetInsightsGet, Mapping[str, object], None]) – requests.AssetInsightsGet, optional

  • **kwargs (object) –

    Extra parameters for requests.AssetInsightsGet
    • get_asset_insights: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[AssetInsightsItem], AssetInsightsGetPaginated]

fields = None
model_config = {'extra': 'allow', 'use_enum_values': True, 'validate_assignment': True, 'validate_default': True}

Configuration for the model, should be a dictionary conforming to [ConfigDict][pydantic.config.ConfigDict].

model_post_init(context, /)

This function is meant to behave like a BaseModel method to initialise private attributes.

It takes context as an argument since that’s what pydantic-core passes when calling it.

Parameters:
  • self (BaseModel) – The BaseModel instance.

  • context (Any) – The context.

Return type:

None

schema = None

ControlChange

Kelvin API Client.

class kelvin.api.client.api.control_change.ControlChange(_owner=None, _name=None, **kwargs)[source]

Bases: ApiServiceModel

Parameters:
  • _owner (Optional['BaseModel'])

  • _name (Optional[str])

  • kwargs (object)

classmethod get_control_change_clustering(data=None, _dry_run=False, _client=None, **kwargs)[source]

Retrieve the total count of Control Changes matching an array of resources and filter options between two dates grouped by the parameter time_bucket. Will also return a list of all the Control Change `id`s counted.

Permission Required: kelvin.permission.control_change.read.

getControlChangeClustering: POST /api/v4/control-changes/clustering/get

Parameters:
  • data (Union[ControlChangeClusteringGet, Mapping[str, object], None]) – requests.ControlChangeClusteringGet, optional

  • **kwargs (object) –

    Extra parameters for requests.ControlChangeClusteringGet
    • get_control_change_clustering: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

KList[ControlChangeClustering]

classmethod create_control_change(data=None, _dry_run=False, _client=None, **kwargs)[source]

Send a new value to be written to an Asset / Data Stream pair. The Control Change Manager will automatically find which Cluster and Bridge to communicate the change to.

Permission Required: kelvin.permission.control_change.create.

createControlChange: POST /api/v4/control-changes/create

Parameters:
  • data (Union[ControlChangeCreate, Mapping[str, object], None]) – requests.ControlChangeCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.ControlChangeCreate
    • create_control_change: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

ControlChangeCreate

classmethod get_control_change_last(pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

Returns a dictionary with a data property containing an array of latest Control Change objects. Only the latest Control Changes for each resource in the request filters will be returned.

Permission Required: kelvin.permission.control_change.read.

getControlChangeLast: POST /api/v4/control-changes/last/get

Parameters:
  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • data (Union[ControlChangeLastGet, Mapping[str, object], None]) – requests.ControlChangeLastGet, optional

  • **kwargs (object) –

    Extra parameters for requests.ControlChangeLastGet
    • get_control_change_last: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[ControlChangeGet], ControlChangeLastGetPaginatedResponseCursor]

classmethod list_control_changes(pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

Returns a list of Control Change objects for specific Asset / Data Stream pairs or Control Change IDs. The list can be optionally filtered and sorted on the server before being returned.

Permission Required: kelvin.permission.control_change.read.

listControlChanges: POST /api/v4/control-changes/list

Parameters:
  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • data (Union[ControlChangesList, Mapping[str, object], None]) – requests.ControlChangesList, optional

  • **kwargs (object) –

    Extra parameters for requests.ControlChangesList
    • list_control_changes: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[ControlChangeGet], ControlChangesListPaginatedResponseCursor]

classmethod get_control_change_range(pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

Returns a dictionary with a data property containing an array of Control Changes within a specified time range for all of the resources in the resources array that match the filter options.

Permission Required: kelvin.permission.control_change.read.

getControlChangeRange: POST /api/v4/control-changes/range/get

Parameters:
  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • data (Union[ControlChangeRangeGet, Mapping[str, object], None]) – requests.ControlChangeRangeGet, optional

  • **kwargs (object) –

    Extra parameters for requests.ControlChangeRangeGet
    • get_control_change_range: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[ControlChangeGet], ControlChangeRangeGetPaginatedResponseCursor]

classmethod delete_control_change(control_change_id, _dry_run=False, _client=None)[source]

Deletes a control change

Permission Required: kelvin.permission.control_change.delete.

deleteControlChange: POST /api/v4/control-changes/{control_change_id}/delete

Parameters:
  • control_change_id (str) – str, optional A unique randomly generated UUID as the key id for the Control Change.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

None

classmethod get_control_change(control_change_id, _dry_run=False, _client=None)[source]

Retrieves the properties, status and all associated logs of a Control Change.

Permission Required: kelvin.permission.control_change.read.

getControlChange: GET /api/v4/control-changes/{control_change_id}/get

Parameters:
  • control_change_id (str) – str, optional A unique randomly generated UUID as the key id for the Control Change.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

ControlChangeGet

fields = None
model_config = {'extra': 'allow', 'use_enum_values': True, 'validate_assignment': True, 'validate_default': True}

Configuration for the model, should be a dictionary conforming to [ConfigDict][pydantic.config.ConfigDict].

model_post_init(context, /)

This function is meant to behave like a BaseModel method to initialise private attributes.

It takes context as an argument since that’s what pydantic-core passes when calling it.

Parameters:
  • self (BaseModel) – The BaseModel instance.

  • context (Any) – The context.

Return type:

None

schema = None

CustomActions

Kelvin API Client.

class kelvin.api.client.api.custom_actions.CustomActions(_owner=None, _name=None, **kwargs)[source]

Bases: ApiServiceModel

Parameters:
  • _owner (Optional['BaseModel'])

  • _name (Optional[str])

  • kwargs (object)

classmethod create_custom_action(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create Custom Action

Permission Required: kelvin.permission.custom-actions.create.

createCustomAction: POST /api/v4/custom-actions/create

Parameters:
  • data (Union[CustomActionCreate, Mapping[str, object], None]) – requests.CustomActionCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.CustomActionCreate
    • create_custom_action: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

CustomActionCreate

classmethod list_custom_actions(pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

Returns a list of Custom Action objects. The list can be optionally filtered and sorted on the server before being returned.

Permission Required: kelvin.permission.custom-actions.read.

listCustomActions: POST /api/v4/custom-actions/list

Parameters:
  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • data (Union[CustomActionsList, Mapping[str, object], None]) – requests.CustomActionsList, optional

  • **kwargs (object) –

    Extra parameters for requests.CustomActionsList
    • list_custom_actions: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[CustomAction], CustomActionsListPaginatedResponseCursor]

classmethod create_custom_actions_type(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create a new Custom Action Type.

Permission Required: kelvin.permission.custom-actions.create.

createCustomActionsType: POST /api/v4/custom-actions/types/create

Parameters:
  • data (Union[CustomActionsTypeCreate, Mapping[str, object], None]) – requests.CustomActionsTypeCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.CustomActionsTypeCreate
    • create_custom_actions_type: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

CustomActionsTypeCreate

classmethod list_custom_actions_types(pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, search=None, app_names=None, fetch=True, _dry_run=False, _client=None)[source]

Returns a list of Custom Action Type objects. The list can be optionally filtered and sorted on the server before being returned. Permission Required: kelvin.permission.custom-actions.read.

listCustomActionsTypes: GET /api/v4/custom-actions/types/list

Parameters:
  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • search (Optional[Sequence[str]]) – Sequence[str] Search and filter on the list based on the key name and title. The search is case insensitive and will find partial matches as well.

  • app_names (Optional[Sequence[str]]) – Sequence[str] Filter the list of custom action types to include only those that are currently in use by the specified applications.

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

Union[KList[CustomActionType], CustomActionsTypesListPaginatedCursor]

classmethod delete_custom_action_type(name, _dry_run=False, _client=None)[source]

Permanently delete an existing Custom Action Type. An error will be returned if there are any current Custom Action linked to the Custom Action Type. This cannot be undone once the API request has been submitted.

Permission Required: kelvin.permission.custom-actions.delete.

deleteCustomActionType: POST /api/v4/custom-actions/types/{name}/delete

Parameters:
  • name (str) – str, optional Custom Action Type key name to delete. Case sensitive name.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

None

classmethod get_custom_actions_type(name, _dry_run=False, _client=None)[source]

Retrieves the parameters of a Custom Action Type.

Permission Required: kelvin.permission.custom-actions.read.

getCustomActionsType: GET /api/v4/custom-actions/types/{name}/get

Parameters:
  • name (str) – str, optional Custom Action Type key name to get. Case sensitive name.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

CustomActionsTypeGet

classmethod update_custom_actions_type(name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Updates an existing Custom Action Type with any new values passed through the body parameters. All body parameters are optional and if not provided will remain unchanged. Only the unique identifier name can not be changed.

Permission Required: kelvin.permission.custom-actions.update.

updateCustomActionsType: POST /api/v4/custom-actions/types/{name}/update

Parameters:
  • name (str) – str, optional Custom Action Type key name to update. Case sensitive name.

  • data (Union[CustomActionsTypeUpdate, Mapping[str, object], None]) – requests.CustomActionsTypeUpdate, optional

  • **kwargs (object) –

    Extra parameters for requests.CustomActionsTypeUpdate
    • update_custom_actions_type: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

CustomActionsTypeUpdate

classmethod delete_custom_action(action_id, _dry_run=False, _client=None)[source]

Permanently delete an existing Custom Action.

Permission Required: kelvin.permission.custom-actions.delete.

deleteCustomAction: POST /api/v4/custom-actions/{action_id}/delete

Parameters:
  • action_id (str) – str, optional

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

None

classmethod get_custom_action(action_id, _dry_run=False, _client=None)[source]

Get Custom Action

Permission Required: kelvin.permission.custom-actions.read.

getCustomAction: GET /api/v4/custom-actions/{action_id}/get

Parameters:
  • action_id (str) – str, optional

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

CustomActionGet

fields = None
model_config = {'extra': 'allow', 'use_enum_values': True, 'validate_assignment': True, 'validate_default': True}

Configuration for the model, should be a dictionary conforming to [ConfigDict][pydantic.config.ConfigDict].

model_post_init(context, /)

This function is meant to behave like a BaseModel method to initialise private attributes.

It takes context as an argument since that’s what pydantic-core passes when calling it.

Parameters:
  • self (BaseModel) – The BaseModel instance.

  • context (Any) – The context.

Return type:

None

schema = None

DataQuality

Kelvin API Client.

class kelvin.api.client.api.data_quality.DataQuality(_owner=None, _name=None, **kwargs)[source]

Bases: ApiServiceModel

Parameters:
  • _owner (Optional['BaseModel'])

  • _name (Optional[str])

  • kwargs (object)

classmethod delete_bulk_data_quality(data=None, _dry_run=False, _client=None, **kwargs)[source]

Deletes multiple data quality configurations.

Permission Required: kelvin.permission.data-quality.delete.

deleteBulkDataQuality: POST /api/v4/data-quality/configuration/bulk/delete

Parameters:
  • data (Union[BulkDataQualityDelete, Mapping[str, object], None]) – requests.BulkDataQualityDelete, optional

  • **kwargs (object) –

    Extra parameters for requests.BulkDataQualityDelete
    • delete_bulk_data_quality: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod upsert_bulk_data_quality(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create or update multiple data quality configurations at once.

Permission Required: kelvin.permission.data-quality.create.

upsertBulkDataQuality: POST /api/v4/data-quality/configuration/bulk/upsert

Parameters:
  • data (Union[BulkDataQualityUpsert, Mapping[str, object], None]) – requests.BulkDataQualityUpsert, optional

  • **kwargs (object) –

    Extra parameters for requests.BulkDataQualityUpsert
    • upsert_bulk_data_quality: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod create_data_quality(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create a new Data Quality Configuration.

A data Quality is a configuration that defines all the algorithms being used to monitor a resource data quality.

All configurations are optional. There are no validations done regarding each configuration content.

Permission Required: kelvin.permission.data-quality.create.

createDataQuality: POST /api/v4/data-quality/configuration/create

Parameters:
  • data (Union[DataQualityCreate, Mapping[str, object], None]) – requests.DataQualityCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.DataQualityCreate
    • create_data_quality: str

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

DataQualityCreate

classmethod list_data_quality(pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, search=None, sort_by=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

List data quality configurations based on the provided filters.

Permission Required: kelvin.permission.data-quality.read.

listDataQuality: POST /api/v4/data-quality/configuration/list

Parameters:
  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • search (Optional[Sequence[str]]) – Sequence[str] Search for data qualities with resources matching the search term.

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • data (Union[DataQualityList, Mapping[str, object], None]) – requests.DataQualityList, optional

  • **kwargs (object) –

    Extra parameters for requests.DataQualityList
    • list_data_quality: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[DataQuality], DataQualityListPaginatedResponseCursor]

classmethod delete_data_quality(resource, _dry_run=False, _client=None)[source]

Delete a Data Quality configuration by resource.

Permission Required: kelvin.permission.data-quality.delete.

deleteDataQuality: POST /api/v4/data-quality/configuration/{resource}/delete

Parameters:
  • resource (str) – str, optional Asset Data Stream pair for deleting the associated DataQuality configurations. (example: krn:ad:asset1/setpoint).

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

None

classmethod get_data_quality(resource, _dry_run=False, _client=None)[source]

Get a Data Quality configuration by resource.

Permission Required: kelvin.permission.data-quality.read.

getDataQuality: GET /api/v4/data-quality/configuration/{resource}/get

Parameters:
  • resource (str) – str, optional Asset/Data Stream pair to retrieve the associated DataQuality configurations. (example: krn:ad:asset1/setpoint).

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

DataQualityGet

classmethod update_data_quality(resource, data=None, _dry_run=False, _client=None, **kwargs)[source]

Update a Data Quality by providing the new configuration. This request changes the whole Data Quality Configuration.

Permission Required: kelvin.permission.data-quality.update.

updateDataQuality: POST /api/v4/data-quality/configuration/{resource}/update

Parameters:
  • resource (str) – str, optional Asset Data Stream pair to update the associated Data Quality configurations. (example: krn:ad:asset1/setpoint).

  • data (Union[DataQualityUpdate, Mapping[str, object], None]) – requests.DataQualityUpdate, optional

  • **kwargs (object) –

    Extra parameters for requests.DataQualityUpdate
    • update_data_quality: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

DataQualityUpdate

classmethod bulk_delete_data_quality_metrics(data=None, _dry_run=False, _client=None, **kwargs)[source]

Delete multiple Data Quality Metrics by their names in a single request.

Permission Required: kelvin.permission.data-quality.delete.

bulkDeleteDataQualityMetrics: POST /api/v4/data-quality/metric/bulk/delete

Parameters:
  • data (Union[DeleteDataQualityMetricsBulk, Mapping[str, object], None]) – requests.DeleteDataQualityMetricsBulk, optional

  • **kwargs (object) –

    Extra parameters for requests.DeleteDataQualityMetricsBulk
    • bulk_delete_data_quality_metrics: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod bulk_upsert_data_quality_metrics(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create or update multiple Data Quality Metrics in a single request.

Permission Required: kelvin.permission.data-quality.create and kelvin.permission.data-quality.update.

bulkUpsertDataQualityMetrics: POST /api/v4/data-quality/metric/bulk/upsert

Parameters:
  • data (Union[UpsertDataQualityMetricsBulk, Mapping[str, object], None]) – requests.UpsertDataQualityMetricsBulk, optional

  • **kwargs (object) –

    Extra parameters for requests.UpsertDataQualityMetricsBulk
    • bulk_upsert_data_quality_metrics: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

None

classmethod create_data_quality_metric(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create a new Data Quality Metric.

Permission Required: kelvin.permission.data-quality.create.

createDataQualityMetric: POST /api/v4/data-quality/metric/create

Parameters:
  • data (Union[DataQualityMetricCreate, Mapping[str, object], None]) – requests.DataQualityMetricCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.DataQualityMetricCreate
    • create_data_quality_metric: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

DataQualityMetricCreate

classmethod list_data_quality_metrics(pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

Returns a list of Data Quality Metrics and its parameters. The Data Quality Metrics can be optionally filtered and sorted on the server before being returned.

Permission Required: kelvin.permission.data-quality.read.

listDataQualityMetrics: POST /api/v4/data-quality/metric/list

Parameters:
  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • data (Union[DataQualityMetricsList, Mapping[str, object], None]) – requests.DataQualityMetricsList, optional

  • **kwargs (object) –

    Extra parameters for requests.DataQualityMetricsList
    • list_data_quality_metrics: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[DataQualityMetric], DataQualityMetricsListPaginatedResponseCursor]

classmethod delete_data_quality_metric(metric_name, _dry_run=False, _client=None)[source]

Delete a Data Quality Metric by name.

Permission Required: kelvin.permission.data-quality.delete.

deleteDataQualityMetric: POST /api/v4/data-quality/metric/{metric_name}/delete

Parameters:
  • metric_name (str) – str, optional The unique identifier name of the Data Quality Metric to delete.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

None

classmethod get_data_quality_metric(metric_name, _dry_run=False, _client=None)[source]

Retrieve the parameters of a Data Quality Metric.

Permission Required: kelvin.permission.data-quality.read.

getDataQualityMetric: GET /api/v4/data-quality/metric/{metric_name}/get

Parameters:
  • metric_name (str) – str, optional The unique identifier name of the Data Quality Metric to retrieve.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

DataQualityMetricGet

classmethod update_data_quality_metric(metric_name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Update an existing Data Quality Metric.

Permission Required: kelvin.permission.data-quality.update.

updateDataQualityMetric: POST /api/v4/data-quality/metric/{metric_name}/update

Parameters:
  • metric_name (str) – str, optional The unique identifier name of the Data Quality Metric to update.

  • data (Union[DataQualityMetricUpdate, Mapping[str, object], None]) – requests.DataQualityMetricUpdate, optional

  • **kwargs (object) –

    Extra parameters for requests.DataQualityMetricUpdate
    • update_data_quality_metric: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

DataQualityMetricUpdate

classmethod data_quality_simulate(data=None, _dry_run=False, _client=None, **kwargs)[source]

Simulate the effect of data quality updates without making permanent changes.

Permission Required: kelvin.permission.data-quality.read.

DataQualitySimulate: POST /api/v4/data-quality/simulate

Parameters:
  • data (Union[DataQualitySimulate, Mapping[str, object], None]) – requests.DataQualitySimulate, optional

  • **kwargs (object) –

    Extra parameters for requests.DataQualitySimulate
    • data_quality_simulate: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

DataQualitySimulate

classmethod data_quality_statistics(data=None, _dry_run=False, _client=None, **kwargs)[source]

Retrieve data quality statistics regarding the ‘kelvin_data_quality_score’ metric.

Permission Required: kelvin.permission.data-quality.read.

DataQualityStatistics: POST /api/v4/data-quality/statistics

Parameters:
  • data (Union[DataQualityStatistics, Mapping[str, object], None]) – requests.DataQualityStatistics, optional

  • **kwargs (object) –

    Extra parameters for requests.DataQualityStatistics
    • data_quality_statistics: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

DataQualityStatistics

fields = None
model_config = {'extra': 'allow', 'use_enum_values': True, 'validate_assignment': True, 'validate_default': True}

Configuration for the model, should be a dictionary conforming to [ConfigDict][pydantic.config.ConfigDict].

model_post_init(context, /)

This function is meant to behave like a BaseModel method to initialise private attributes.

It takes context as an argument since that’s what pydantic-core passes when calling it.

Parameters:
  • self (BaseModel) – The BaseModel instance.

  • context (Any) – The context.

Return type:

None

schema = None

DataTag

Kelvin API Client.

class kelvin.api.client.api.data_tag.DataTag(_owner=None, _name=None, **kwargs)[source]

Bases: ApiServiceModel

Parameters:
  • _owner (Optional['BaseModel'])

  • _name (Optional[str])

  • kwargs (object)

classmethod create_data_tag(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create a new Data Tag event.

Permission Required: kelvin.permission.datatag.create.

createDataTag: POST /api/v4/datatags/create

Parameters:
  • data (Union[DataTagCreate, Mapping[str, object], None]) – requests.DataTagCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.DataTagCreate
    • create_data_tag: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

DataTagCreate

classmethod list_data_tag(pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, data=None, fetch=True, _dry_run=False, _client=None, **kwargs)[source]

Returns a list of Data Tags. The Data Tags can be optionally filtered and sorted on the server before being returned.

Permission Required: kelvin.permission.datatag.read.

listDataTag: POST /api/v4/datatags/list

Parameters:
  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • data (Union[DataTagList, Mapping[str, object], None]) – requests.DataTagList, optional

  • **kwargs (object) –

    Extra parameters for requests.DataTagList
    • list_data_tag: dict

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

Union[KList[DataTag], DataTagListPaginatedResponseCursor]

classmethod create_tag(data=None, _dry_run=False, _client=None, **kwargs)[source]

Create a new Tag.

Permission Required: kelvin.permission.datatag.create.

createTag: POST /api/v4/datatags/tags/create

Parameters:
  • data (Union[TagCreate, Mapping[str, object], None]) – requests.TagCreate, optional

  • **kwargs (object) –

    Extra parameters for requests.TagCreate
    • create_tag: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

TagCreate

classmethod list_tag(search=None, names=None, pagination_type=None, page_size=10000, page=None, next=None, previous=None, direction=None, sort_by=None, fetch=True, _dry_run=False, _client=None)[source]

Returns a list of Tags. The Tags can be optionally filtered and sorted on the server before being returned.

Permission Required: kelvin.permission.datatag.read.

listTag: GET /api/v4/datatags/tags/list

Parameters:
  • search (Optional[Sequence[str]]) – Sequence[str] Search and filter on the list based on the key name (Tag Name). All values in array will be filtered as OR. The search is case insensitive and will find partial matches as well.

  • names (Optional[Sequence[str]]) – Sequence[str] Filter on the list based on the key name (Tag Name). All values in array will be filtered as OR. The search is case insensitive and is on the full Tags name only.

  • pagination_type (Optional[Literal['limits', 'cursor', 'stream']]) – Literal['limits', 'cursor', 'stream'] Method of pagination to use for return results where total_items is greater than page_size. cursor and limits will return one page of results, stream will return all results. (‘limits’, ‘cursor’, ‘stream’)

  • page_size (Optional[int]) – int Number of objects to be returned in each page. Page size can range between 1 and 10000 objects.

  • page (Optional[int]) – int An integer for the wanted page of results. Used only with pagination_type set as limits.

  • next (Optional[str]) – str An alphanumeric string bookmark to indicate where to start for the next page. Used only with pagination_type set as cursor.

  • previous (Optional[str]) – str An alphanumeric string bookmark to indicate where to end for the previous page. Used only with pagination_type set as cursor.

  • direction (Optional[Literal['asc', 'desc']]) – Literal['asc', 'desc'] Sorting order according to the sort_by parameter. (‘asc’, ‘desc’)

  • sort_by (Optional[Sequence[str]]) – Sequence[str]

  • fetch (bool)

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

Union[KList[Tag], TagListPaginatedResponseCursor]

classmethod delete_tag(tag_name, _dry_run=False, _client=None)[source]

Permanently delete an existing Tag. An error will be returned if there are any current links to a DataTag and the Tag will not be deleted. Permission Required: kelvin.permission.datatag.delete.

deleteTag: POST /api/v4/datatags/tags/{tag_name}/delete

Parameters:
  • tag_name (str) – str, optional Tag key name.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

None

classmethod get_tag(tag_name, _dry_run=False, _client=None)[source]

Retrieves a Tag.

Permission Required: kelvin.permission.datatag.read.

getTag: GET /api/v4/datatags/tags/{tag_name}/get

Parameters:
  • tag_name (str) – str, optional Tag key name.

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

Return type:

TagGet

classmethod update_tag(tag_name, data=None, _dry_run=False, _client=None, **kwargs)[source]

Update an existing Tag. The Tag key name can not be updated.

Permission Required: kelvin.permission.datatag.update.

updateTag: POST /api/v4/datatags/tags/{tag_name}/update

Parameters:
  • tag_name (str) – str, optional Tag key name.

  • data (Union[TagUpdate, Mapping[str, object], None]) – requests.TagUpdate, optional

  • **kwargs (object) –

    Extra parameters for requests.TagUpdate
    • update_tag: dict

  • _dry_run (bool)

  • _client (SyncBaseClient | None)

  • **kwargs

Return type:

TagUpdate

classmethod delete_data_tag(datatag_id, _dry_run=False, _client=None)[source]

Permanently delete an existing Data Tag. Permission Required: kelvin.permission.datatag.delete.

deleteDataTag: POST /api/v4/datatags/{datatag_id}/delete

Parameters:
  • datatag_id (str) – str, optional Data Tag key id. The string can only contain alphanumeric characters and - character.

  • _dry_run (bool)

[...]
